//+------------------------------------------------------------------+
//|                                         Heiken Ashi Smoothed.mq4 |
//|                                                                  |
//|                                                      mod by Raff |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 RoyalBlue
#property indicator_color3 Red
#property indicator_color4 RoyalBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 3
#property indicator_width4 3
//---- parameters
extern ENUM_MA_METHOD MaMetod =2;
extern int            MaPeriod=6;
extern ENUM_MA_METHOD MaMetod2 =3;
extern int            MaPeriod2=2;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3, ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexBuffer(7,ExtMapBuffer8);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int    limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
    
    //
    //
    //
    //
    //
    
    for (int pos=limit; pos >= 0; pos--)
    {
       double maOpen=iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN,pos);
       double maClose=iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
       double maLow=iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW,pos);
       double maHigh=iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH,pos);
//----
      double haOpen=(ExtMapBuffer5[pos+1]+ExtMapBuffer6[pos+1])/2;
      double haClose=(maOpen+maHigh+maLow+maClose)/4;
      double haHigh=MathMax(maHigh, MathMax(haOpen, haClose));
      double haLow=MathMin(maLow, MathMin(haOpen, haClose));
      if (haOpen<haClose)
        {
         ExtMapBuffer7[pos]=haLow;
         ExtMapBuffer8[pos]=haHigh;
        }
      else
        {
         ExtMapBuffer7[pos]=haHigh;
         ExtMapBuffer8[pos]=haLow;
        }
      ExtMapBuffer5[pos]=haOpen;
      ExtMapBuffer6[pos]=haClose;
    
     }
   
   for (pos=limit; pos >= 0; pos--) ExtMapBuffer1[pos]=iMAOnArray(ExtMapBuffer7,Bars,MaPeriod2,0,MaMetod2,pos);
   for (pos=limit; pos >= 0; pos--) ExtMapBuffer2[pos]=iMAOnArray(ExtMapBuffer8,Bars,MaPeriod2,0,MaMetod2,pos);
   for (pos=limit; pos >= 0; pos--) ExtMapBuffer3[pos]=iMAOnArray(ExtMapBuffer5,Bars,MaPeriod2,0,MaMetod2,pos);
   for (pos=limit; pos >= 0; pos--) ExtMapBuffer4[pos]=iMAOnArray(ExtMapBuffer6,Bars,MaPeriod2,0,MaMetod2,pos);
//----
   return(0);
  }
//+------------------------------------------------------------------+